<?php

////////////////////////////////////////////////////////
//										darkPoll v o.3                  //
//											 by YoGi                      //
////////////////////////////////////////////////////////
//																										//
//	   Coded for : Darkmag [http://darkmag.net]		    //
//  	 First Release : 03/12/2000											//
//     email : webmaster@darkmag.net								  //
// 																										//
////////////////////////////////////////////////////////


////////////////////////////////////////////////////////////
//																									    	//
//	usage :																						    //
//		void display_poll($IDpoll,$url) ;								    //
//		void display_poll_results($IDpoll) ;					    	//
//	  string display_poll_desc($IDpoll)	;		              //
//	  string display_poll_date($IDpoll)	;		              //
//		 																								    //
//  voir darkPollTest.php3 pour un exemple d'utilisation  //
////////////////////////////////////////////////////////////



///////////////////// Variables de configuration de darkPoll /////////////////


$dark_host = "host" ;											// serveur SQL
$dark_user = "user" ;											// username
$dark_pwd = "pwd" ;												// password

$dark_poll_DB = "database" ;							// DB dans laquelle sont stockes les tables	

$dark_poll_TBL = "poll" ;									// table de dfinition des polls
$dark_poll_options_TBL = "poll_options" ;	// table de dfinition des choix
$dark_poll_log_TBL = "poll_log"; 					// table des logs

$dark_already_connected = 0 ; 						// 1 : connexion tablie pralablement / 0 : tablir la connexion
$dark_var_link_db = "link" ;							// le nom de la variable de connexion (soit prtablie, soit dja affecte)
$dark_do_log = 1 ;												// 0 : ne pas loger les votes / 1 : les loger [et checker/bloquer les IPs]

$dark_img = "./darkPoll.gif"	; 					// chemin/image  utiliser pour les barres du diagramme
$dark_img_blank = "./darkBlank.gif" ;			// chemin de l'image darkBlank.gif
$dark_img_height = 11 ;										// la hauteur de l'image "darkPoll" (en pixels)

$dark_time_valid = 24 ;										// dure du bloquage et de l'affichage automatique des resultats (en heure)

$dark_poll_width = "100%" ;								// width du tableau de slection ["" pour ajustement automatique]
$dark_result_width = "" ;									// width du tableau de rsultat  ["" pour ajustement automatique]

$dark_poll_tbl_align = "left" ;						// alignement du tableau de slection {"left","right","center",""} ["" pour ajustement automatique]
$dark_result_tbl_align = "center" ;				// alignement du tableau de rsultat  {"left","right","center",""} ["" pour ajustement automatique]
$dark_submit_align = "center" ;						// alignement du bouton de validation [en fonction de $dark_poll_width] {"left","right","center"} 

$dark_display_total = 1 ;									// 1 pour afficher le total, 0 pour le masquer [rsultat]
$dark_display_stats = 1 ;									// 1 pour afficher les pourcentage, 2 pour les stats, 0 pour rien [rsultat]
	
$dark_style_options = "FONT-SIZE: 10px;" ;							// style [CSS] des diffrents choix ["" pour valeurs par dfaut]
$dark_style_percent = "FONT-SIZE: 10px;" ;							// style [CSS] des "statistiques" dans le resultat ["" pour valeurs par dfaut]
$dark_style_total =  "FONT-WEIGHT: BOLD;" ;							// style [CSS] du total (dans le resultat) ["" pour valeurs par dfaut]
$dark_style_submit = "HEIGHT:22px; FONT-SIZE: 10px;" ;	// style [CSS] pour le bouton de validation (dans la slection) ["" pour valeurs par dfaut]









///////////////////// Gestion des Cookies/Forms //////////////////////////////

$darkCookiePoll = $HTTP_COOKIE_VARS["darkPoll"] ;

$test_poll_cookie = $HTTP_POST_VARS["pollValid"] ;

if ($test_poll_cookie == "true") {
	setcookie ("darkPoll","true",time()+($dark_time_valid * 3600),"","",0) ;	
	$darkIDvote = $HTTP_POST_VARS["IDvote"] ;
}

//////////////////// Fonctions de gestion du poll ////////////////////////////

function db_connect() {
	global $dark_host,$dark_user,$dark_pwd,$dark_poll_DB ;

	$temp = mysql_connect($dark_host,$dark_user,$dark_pwd) ;
	mysql_select_db($dark_poll_DB,$temp) ;
	return $temp ;
}


function db_close($link) {
	mysql_close($link) ;
}

function darkAddSlashes($chaine ) {
 return( get_magic_quotes_gpc() == 1 ? 
          $chaine : 
          AddSlashes($chaine) );
}

function darkStripSlashes($chaine) {
  return( get_magic_quotes_gpc() == 1 ? 
          StripSlashes($chaine) : 
          $chaine );
}

function display_poll_desc($IDpoll) {
	global $dark_already_connected, $dark_var_link_db, $$dark_var_link_db, $dark_poll_TBL ;

	if (!$dark_already_connected) 
		$$dark_var_link_db = db_connect() ;

	if ($IDpoll==0) { // si $IDpoll vaut 0, alors on affiche le dernier poll de la DB
		$sql_test = "SELECT max(ID) FROM $dark_poll_TBL" ;
		$res_test = mysql_query($sql_test,$$dark_var_link_db) ;
		$tab_test = mysql_fetch_row($res_test) ;
		$IDpoll = $tab_test[0];
	}	

	$sql = "SELECT description FROM $dark_poll_TBL WHERE ID='$IDpoll'" ;
	$res = mysql_query($sql,$$dark_var_link_db) or die ("requete displayHeaderPoll incorrecte") ;
	$tab = mysql_fetch_row($res) ;

	if (!$dark_already_connected) 
		db_close($$dark_var_link_db) ;

	return darkStripSlashes($tab[0]) ;
}
	
	
function displayNewPoll($IDpoll,$url) {
	global $dark_already_connected, $dark_var_link_db, $$dark_var_link_db,$dark_poll_options_TBL,$dark_poll_tbl_align,$dark_poll_width,$dark_style_options,$dark_submit_align,$dark_img_blank,$dark_style_submit  ;

	if (!$dark_already_connected) 
		$$dark_var_link_db = db_connect() ;
	
	$sql = "SELECT ID,texte FROM $dark_poll_options_TBL WHERE IDpoll='$IDpoll' ORDER BY ID" ;
	$res = mysql_query($sql,$$dark_var_link_db) or die ("requete displayNewPoll incorrecte") ;
		
	echo "<FORM NAME='darkPoll' METHOD='POST' ACTION='$url'>\n" ;
	
	if ($dark_poll_width == "") 
		echo "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 ALIGN='$dark_poll_tbl_align'>" ;
	else
		echo "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 ALIGN='$dark_poll_tbl_align' WIDTH='$dark_poll_width'>" ;
	
	$i=1 ;
	
	while ($tab = mysql_fetch_array($res)) {
		echo "<TR>" ;
		
		if ($dark_style_options != "")
			echo "<TD VALIGN='top' STYLE='$dark_style_options'>\n<INPUT TYPE='radio' NAME='IDvote' VALUE='".$tab["ID"]."'" ;
		else 
			echo "<TD VALIGN='top'>\n<INPUT TYPE='radio' NAME='IDvote' VALUE='".$tab["ID"]."'" ;
			
		if ($i == 1) echo " checked" ;
		echo ">\n" ;
		echo "<IMG SRC='".$dark_img_blank."'></TD><TD>".darkStripSlashes($tab["texte"]) ;
		echo "\n</TD></TR>\n" ;
		$i=0 ;
	}
	
	echo "<TR><TD><BR></TD></TR>\n" ;
	echo "<TR><TD COLSPAN=2 ALIGN='$dark_submit_align'>&nbsp;&nbsp;" ;

	if($dark_style_submit != "") 
		echo "<INPUT TYPE='submit' VALUE='Voter !' STYLE='".$dark_style_submit."'>" ;
	else
		echo "<INPUT TYPE='submit' VALUE='Voter !'>" ;
		
	echo "</TD></TR>\n" ;

	echo "<INPUT TYPE='hidden' NAME='pollValid' VALUE='true'>\n" ;
	
	echo "</TABLE>\n" ;
	echo "</FORM>\n" ;

	if (!$dark_already_connected) 
		db_close($$dark_var_link_db) ;
}


function display_poll_results($IDpoll) {
	global $dark_already_connected, $dark_var_link_db, $$dark_var_link_db,$dark_poll_TBL, $dark_poll_options_TBL,$dark_img,$dark_img_height,$dark_result_tbl_align,$dark_img_blank,$dark_result_width,$dark_display_total,$dark_display_stats,$dark_style_options,$dark_style_percent,$dark_style_total ;
	
	if (!$dark_already_connected) 
		$$dark_var_link_db = db_connect() ;
	
	$sql_total = "SELECT sum(nbvotes) FROM $dark_poll_options_TBL WHERE IDpoll='$IDpoll'" ;
	$res_total = mysql_query($sql_total,$$dark_var_link_db) or die ("requete count incorrecte") ;
	$tab_total = mysql_fetch_row($res_total) ;
	$nb_total = $tab_total[0] ;
	
	$sql = "SELECT texte,nbvotes from $dark_poll_options_TBL WHERE IDpoll='$IDpoll' ORDER BY ID" ;
	$res = mysql_query($sql,$$dark_var_link_db) or die ("requete globale incorrecte") ;
	
	if ($dark_result_width == "") 
		echo "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=1 ALIGN='$dark_result_tbl_align'>\n" ;
	else 
		echo "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=1 ALIGN='$dark_result_tbl_align' WIDTH='$dark_result_width'>\n" ;
	
	while ($tab = mysql_fetch_array($res)) {
		
		if ($nb_total) {
			$percent = $tab["nbvotes"] * 100 / $nb_total ;
			$percent = round($percent*100)/100 ;
			if ($percent == 0) $percent = "0,00" ;
		}
		else {
			$percent = "0,00" ;
		}
				
		$width = round($percent) ;
		
		echo "<TR HEIGHT=$dark_img_height>\n" ;
		
		if ($dark_style_options != "" )
			echo "<TD ALIGN='left' VALIGN='middle' STYLE='$dark_style_options'>" ;
		else 
			echo "<TD ALIGN='left' VALIGN='middle'>" ;
		
		echo darkStripSlashes($tab["texte"])."</TD><TD WIDTH=5><IMG SRC='$dark_img_blank'></TD><TD ALIGN='left'>\n" ;
		echo "<TABLE BORDER=0 CELLPADDING=0 CELLSPACING=0 ALIGN='LEFT'>\n" ;
		echo "<TR><TD BACKGROUND='$dark_img' WIDTH='$width' HEIGHT='$dark_img_height'><IMG SRC='$dark_img_blank'></TD></TR>\n" ;
		echo "</TABLE>\n" ;
		echo "</TD>" ;
		
		switch($dark_display_stats) {
			case 0 :
				break ;
				
			case 1 :
				echo "<TD WIDTH=5><IMG SRC='$dark_img_blank'></TD><TD ALIGN='left' VALIGN='middle'" ;
				if ($dark_style_percent != "") echo "STYLE='$dark_style_percent'"; 
				echo ">(".$percent." %)</TD>\n";
				break ;
				
			case 2 :
				echo "<TD WIDTH=5><IMG SRC='$dark_img_blank'></TD><TD ALIGN='left' VALIGN='middle'" ;
				if ($dark_style_percent != "") echo "STYLE='$dark_style_percent'"; 
				echo ">(".$tab["nbvotes"]."/".$nb_total.")</TD>\n";
				break ;
				
			default :
				break ;
		}
		
		echo "</TR><TR><TD HEIGHT=2><IMG SRC='".$dark_img_blank."'></TD></TR>\n";		
	}
	
	if ($dark_display_total) {
		echo "<TR><TD>&nbsp;</TD></TR>" ;
		
		if ($dark_style_total != "" )
			echo "<TR><TD ALIGN='left' colspan=5 STYLE='$dark_style_total'>Total : ".$nb_total." votes</TD></TR>" ;
		else
			echo "<TR><TD ALIGN='left' colspan=5>Total : ".$nb_total." votes</TD></TR>" ;		
	}
	
	echo "</TABLE>"; 
	
	if (!$dark_already_connected) 
		db_close($$dark_var_link_db) ;	
}

	
function addVote($IDvote) {
	global $dark_already_connected, $dark_var_link_db, $$dark_var_link_db, $dark_poll_options_TBL ;
	
	if (!$dark_already_connected) 
		$$dark_var_link_db = db_connect() ;

	$sql = "UPDATE $dark_poll_options_TBL SET nbvotes=nbvotes+1 WHERE ID='$IDvote'" ;
	$res = mysql_query($sql,$$dark_var_link_db) or die ("requete add_vote() incorrecte") ;
			
	if (!$dark_already_connected) 
		db_close($$dark_var_link_db) ;	
}


function addLog($IDvote) {
	global $dark_already_connected, $dark_var_link_db, $$dark_var_link_db, $dark_poll_log_TBL, $REMOTE_ADDR,$HTTP_USER_AGENT ;
	
	if (!$dark_already_connected) 
		$$dark_var_link_db = db_connect() ;

	$date = microtime() ;
	$pos = strrpos($date," ") ;
	$date = substr($date,$pos,strlen($date)) ;
	
	$sql = "INSERT INTO $dark_poll_log_TBL (IDoptions,date,browser,IP) VALUES ($IDvote,'$date','$HTTP_USER_AGENT','$REMOTE_ADDR')" ;
	$res = mysql_query($sql,$$dark_var_link_db) or die ("requete add_log() incorrecte") ;
			
	if (!$dark_already_connected) 
		db_close($$dark_var_link_db) ;	
}


function checkLog() {
	global $dark_already_connected, $dark_var_link_db, $$dark_var_link_db,$REMOTE_ADDR,$dark_poll_log_TBL,$dark_time_valid ;

	if (!$dark_already_connected) 
		$$dark_var_link_db = db_connect() ;
		
	$date = microtime() ;
	$pos = strrpos($date," ") ;
	$date = substr($date,$pos,strlen($date)) ;
	
	$sql = "SELECT count(ID) FROM $dark_poll_log_TBL WHERE IP='$REMOTE_ADDR' AND (date+(3600*$dark_time_valid))>$date"; 
	$res = mysql_query($sql,$$dark_var_link_db) or die ("requete check_log() incorrecte") ;
	$tab = mysql_fetch_row($res) ;
	
	if (!$dark_already_connected) 
		db_close($$dark_var_link_db) ;	
	
	return !$tab[0] ;	// true si il n'a pas vot en dehors de la limite du tps, false sinon
}


function display_poll($IDpoll,$url) {
	global $test_poll_cookie,$$dark_var_link_db,$dark_var_link_db,$darkCookiePoll,$dark_do_log,$darkIDvote ;
	
	if (!$dark_already_connected) 
		$$dark_var_link_db = db_connect() ;
		
	if ($IDpoll==0) { // si $IDpoll vaut 0, alors on affiche le dernier poll de la DB
		$sql_test = "SELECT max(ID) FROM $dark_poll_TBL" ;
		$res_test = mysql_query($sql_test,$$dark_var_link_db) ;
		$tab_test = mysql_fetch_row($res_test) ;
		$IDpoll = $tab_test[0];
	}	
	
	if (!$dark_already_connected) 
		db_close($$dark_var_link_db) ;	
	
	if ($test_poll_cookie == "true") {
		if ($dark_do_log) {
			if (checkLog()) {
				addVote($darkIDvote) ;
				addLog($darkIDvote) ;
			}
		}
		else {
			addVote($darkIDvote) ;
		}
		
		display_poll_results($IDpoll) ;
	}
	
	else {
		if ($dark_do_log) {
			if ( ($darkCookiePoll == "true") || !checkLog() )
				display_poll_results($IDpoll) ;
			else
				displayNewPoll($IDpoll,$url) ;
		}	
		else {
			if ($darkCookiePoll == "true")
				display_poll_results($IDpoll) ;
			else
				displayNewPoll($IDpoll,$url) ;
		}				
	}
}

function display_poll_date($IDpoll) {
	global $dark_already_connected, $dark_var_link_db, $$dark_var_link_db, $dark_poll_TBL ;

	if (!$dark_already_connected) 
		$$dark_var_link_db = db_connect() ;

	if ($IDpoll==0) { // si $IDpoll vaut 0, alors on affiche le dernier poll de la DB
		$sql_test = "SELECT max(ID) FROM $dark_poll_TBL" ;
		$res_test = mysql_query($sql_test,$$dark_var_link_db) ;
		$tab_test = mysql_fetch_row($res_test) ;
		$IDpoll = $tab_test[0];
	}	

	$sql = "SELECT date FROM $dark_poll_TBL WHERE ID=".$IDpoll ;
	$res = mysql_query($sql,$link) or die ("Erreur mySQL / Date") ;
	$tab = mysql_fetch_array($res) ;
		
	if (!$dark_already_connected) 
		db_close($$dark_var_link_db) ;		
		
	return $tab["date"] ;
}

?>
	







